##
##	void waitGPU(void);		/* ҂ */
##	void sendGPU(int cmd, int wait);
##	int bogoVSyncWait(const char *padBuf);
##	int bogoVSyncWait2(const char *padBuf);
##	void softReset(void);
##	void waitButtonRelease(char *padBuf);
##	void InitDMA(void);
##	void CD_Init(void);
##	void CD_changeMode(int mode);
##	void CD_Control(int cmd);	/* r[ */
##
##
##
##
##
.globl waitGPU
.globl sendGPU

.text
.ent waitGPU
.set reorder
waitGPU:
	la	v0, dummybuf
	sw	zero, (v0)
	sw	zero, (v0)
	sw	zero, (v0)
	sw	zero, (v0)
	jr	ra
dummybuf: .word 0
.end waitGPU

.ent sendGPU
sendGPU:
	addiu	sp, sp, -4
	sw	ra, (sp)
	la	t6, $1f801814
	sw	a0, (t6)
	beq a1, zero, nowait

	jal waitGPU
nowait:
	lw	ra, (sp)
	addiu	sp, sp, 4
	jr	ra
.end sendGPU

.globl softReset
.ent softReset
softReset:
	la	t0, 0xbfc00000
	jr	t0
.end softReset

#
#	int bogoVSyncWait(const char *padBuf)
#	int bogoVSyncWait2(const char *padBuf, int count)
#	߂lF񃋁[v
#	wait2 ̂ق PadBuf[0] OŏĂ烋[vB
.globl bogoVSyncWait
.ent bogoVSyncWait
bogoVSyncWait:
	or	v0, zero, zero

stillWait:
	lbu	t0, (a0)

	xori	t0, t0, $ff
	bne	t0, zero, endLoop
	addiu	v0, v0, 1
	j	stillWait

endLoop:
	jr	ra
.end bogoVSyncWait

.globl	bogoVSyncWait2
.ent	bogoVSyncWait2
bogoVSyncWait2:
	addiu	sp, sp, -4
	sw	ra, (sp)

	li	v1, $ff
_callVSyncWait:
	sb	v1, (a0)
	jal	bogoVSyncWait
	addiu	a1, a1, -1
	bgtz	a1, _callVSyncWait

	lw	ra, (sp)
	addiu	sp, sp, 4
	jr	ra
.end	bogoVSyncWait2

##
##	pbhĂȂԂɂȂ̂҂
##	void waitButtonRelease(char *padBuf);
##
##	padBuf[2] == 0xff  padBuf[3] == 0xff łnjB
.globl waitButtonRelease
.ent waitButtonRelease
.set noreorder
waitButtonRelease:
	lbu	t0, 2(a0)
	lbu	t1, 3(a0)
	li	v1, $00ff
	bne	t0, v1, waitButtonRelease
	nop
	bne	t1, v1, waitButtonRelease
	nop
	jr	ra
	nop
.set reorder
.end waitButtonRelease

##
##	InitDMA ( from CD_Init )
##
.globl	InitDMA
.ent	InitDMA
InitDMA:
	lui	t0, $1f80	# t0=1f800000
	sh	zero, $1074(t0)	# *i_mask=0
	lhu	v0, $1074(t0)	# v0=*i_mask
	li	v1, $33333333
	sw	v1, $10f0(t0)	# *d_pcr=$33333333
	sw	zero, $10f4(t0) # *d_icr=0

	jr	ra
.end	InitDMA

##
## CD_Init
##
##	void CD_Init(void)
##

.globl	CD_Init
.ent	CD_Init
CD_Init:
	lui	t0, $1f80
	li	t1, 1
	li	t2, 7

	sb	t1, $1800(t0)	# reg0=1
	lbu	v0, $1803(t0)	# v0=*reg3
	andi	v0, v0, 7	# v0&=7
	beq	v0,zero, _cdi_dontWait
_cdi_waitMore:
	sb	t1, $1800(t0)	# reg0=1
	sb	t2, $1803(t0)	# reg3=7
	sb	t2, $1802(t0)	# reg2=7
	lw	v0, $1803(t0)	# v0=*reg3
	andi	v0, v0, 7
	bne	v0, zero, _cdi_waitMore
_cdi_dontWait:
	sb	zero, $1800(t0)	# reg0=0
	sb	zero, $1803(t0)	# reg3=0
	li	v0, $1325
	sw	v0, $1020(t0)	# com_delay=4901

	jr	ra
.end	CD_Init

##
##	void CD_changeMode(int mode)
##	mode 0: data
##	mode 1: audio
##
##	AUDIO ̂Ƃ arg 80008000
##	Ƃ arg 5b5b5b5b
##
.globl	CD_changeMode
.ent	CD_changeMode
CD_changeMode:
	lui	t0, $1f80
	bne	a0, zero, _doAudio

	li	a0, $5b
	li	a1, $5b
	j	_doAudio_end

_doAudio:
	li	a0, $80
	li	a0, 0

_doAudio_end:
	li	v1, 2
	sb	v1, $1800(t0)	# reg0=2
	sb	a0, $1802(t0)	# reg2=a0
	sb	a1, $1803(t0)	# reg3=a1
	li	v1, 3
	sb	v1, $1800(t0)	# reg0=3
	sb	a0, $1801(t0)	# reg1=a0
	sb	a1, $1802(t0)	# reg2=a1
	li	v1, $20
	sb	v1, $1803(t0)	# reg3=$20

	jr	ra
.end CD_changeMode

##
##	void CD_Control(int cmd);	/* r[ */
##
.globl CD_Control
.ent CD_Control
CD_Control:
	addiu	sp,sp,-8
	sw	ra,(sp)
	sw	s0,4(sp)
	lui	t3, $1f80
	or	s0,zero,a0		#  a0 gĂ܂
	jal	CD_waitReady
	sb	zero,$1800(t3)		# cdrom_reg0=0: send command 

	nop	# ȂǁB
	sb	s0,$1801(t3)		# cdrom_reg1=s0: command
	jal	CD_waitReady

	lw	ra,(sp)
	lw	s0,4(sp)
	addiu	sp,sp,8
	jr	ra
.end CD_Control

#
#	R}h̏I҂܂B
#
.globl CD_waitReady
.ent CD_waitReady
CD_waitReady:
	lui	t3, $1f80
	li	t0,1
	sb	t0,$1800(t3)		# cdrom_reg0=1: get result
	lbu	t1,$1803(t3)		# t1=cdrom_reg3

	andi	t1,t1,7			#  011 s 101 炵B
	beq	t1,zero, _endStopSpin3

_loop1:
	lbu	t0,$1803(t3)		# t0=cdrom_reg3

	andi	t0,t0,7
	bne	t0,t1,_loop1

	li	t2,0
_loop2:
	lbu	t1,$1800(t3)		# t1=cdrom_reg0 t1=status

	andi	t1,t1,$0020		# bit 6 ???
	beq	t1,zero,_endLoop

	lbu	t0,$1801(t3)		# t0=cdrom_reg1 ӖȂH
	addiu	t2,t2,1
	slti	t1,t2,8
	bne	t1,zero,_loop2

_endLoop:
	li	t0,1
	sb	t0,$1800(t3)		# cdrom_reg0=1 get result
	li	t0,7
	sb	t0,$1802(t3)		# cdrom_reg2=7 flush buffer ?
	sb	t0,$1803(t3)		# cdrom_reg3=7 flush irq


_endStopSpin3:
	jr	ra
#	nop
.end CD_waitReady

