#ifndef _HANIMAR_FONT_H_
#define _HANIMAR_FONT_H_

#include "mytypes.h"
#include "gpupkt.h"

typedef struct {
	RECT rect;
	unsigned short fg;
	unsigned short bg;
	const unsigned char *text;
	/* flags below... */
	int curLine;
	int lastLine;	/* ȏ㉺ɃXN[ĂʁAƂs */
} TEXTWIN;

/* x\B */
/* position= y << 16 | x fg,bg = sprite << 15 | r << 10 | g << 5 | b */
unsigned char *KanjiPutc(int code, int position,int fg, int bg);
void KanjiPuts(const unsigned char *str, int position, int fg, int bg);
/* 12bit k */
unsigned char *KanjiPutc12(int code, int position,int fg, int bg);
/* ̊ԂɉPrbg󂫂܂Biqēǂ߂Ij */
void KanjiPuts12(const unsigned char *str, int position, int fg, int bg);

/* k-comm  low level */
void Mem2VRam(unsigned long point, unsigned long size, unsigned long *src);
void VRam2Mem(ulong yx, ulong hw, ushort *dest);

/* pΉ */
void KanaPutc(int c, unsigned long pos, unsigned short fg, unsigned short bg);
void FontPuts(const unsigned char *str,
	unsigned short fg, unsigned short bg, unsigned long pos);

/*
 * TEXTWIN 
 */
/*  */
void TwInit(TEXTWIN *pThis, RECT *pRect,
	unsigned short fg, unsigned short bg, const unsigned char *text);
/* ʂ bg ŃNA ͌_ */
void TwCls(TEXTWIN *pWin, short ox, short oy);
/* XN[ */
void TwScroll(TEXTWIN *pWin, int bector);
bool TwIsScrollable(TEXTWIN *pWin, int bector);
void TwScrollByPage(TEXTWIN *pWin, int bector);
/* \ */
void TwDraw(TEXTWIN *pWin, short ox, short oy);


extern const char SonyFn8x16rkCopyright[];

#endif /* _HANIMAR_FONT_H_ */
