#
#	SJIS tHg 16x15 v 30 byte  12x12 ɕϊB
#

.text
.globl	KanjiReduce
.ent	KanjiReduce
################################################################3
###	void KanjiReduce(char *dest, const char *src, int n);
###	a0	dest: n*n bit 邾̗̈([hPʂŁj
###	a1	src: Kmem2RawAdd() ̖߂l
###	a2	n: A
###
###	gpWX^F v0,v1,t0,t1,t2,t3,t4
################################################################3
KanjiReduce:

	or	v1, zero, a2	# mul  mflo reg1 ̂ŁB
	mul	v1, a2
	or	t0, zero, a0	# t0 = a0
	mflo	v1		# v1 = a2 * a2
	srl	v0, v1, 3	# v0=v1/8
	andi	v1, v1, 7	# v1=v1%8
	beq	v1, zero, clearBuffer

	addiu	v0, v0, 1	# if(v1) v0++

clearBuffer:			# v0 = a0 ̃oCg
	sw	zero, (t0)
	addi	v0, v0, -4
	addiu	t0, t0, 4
	bgtz	v0, clearBuffer

	li	t1, 15		# t1=15
	li	t0, 0		# for (t0 = 0 ; t0 < 15 ; t0 ++)
convMore:
	lbu	v0, (a1)	# v0=src[0]
	lbu	v1, 1(a1)	# v1=src[1]
	sll	v0, v0, 8	# v0<<=8
	or	v0, v0, v1	# v0|=v1
	addiu	a1, a1, 2	# a1+=2

	li	t2, 0		# for (t2 = 0 ; t2 < 16 ; t2 ++)
nextBit:
	andi	v1, v0, $8000	# v1 = v0 & 0x8000
	beq	v1, zero, bitIsOff

	### dest ̂ǂ̃rbg𗧂Ă邩vZ
	### v1 ͎g
	### ܂ X 
	addiu	v1, a2, 0	# v1=a2-0 (a2  size)
	mul	v1, t2		# size * x
###	nop
	mflo	v1
	addiu	v1, v1, 8	# v1 += 8 ľܓ
	srl	t3, v1, 4	# t3 = v1 / 16	;t3 ͉Ԗڂ bit 
	### Y 
	addiu	v1, a2, 0
	mul	v1, t0		# size * y
###	nop
	mflo	v1
	div	v1, t1		# size * y / 15
###	nop
	mfhi	t4
	andi	t4, 8		# t4 &= 8
	beq	t4, zero, zeroMod

	addu	t3, t3, a2	# t3 += size
zeroMod:
	mflo	v1		# ̓AZuɂ񂾂ǁB
	mul	v1, a2		# v1 *= size
###	nop
	mflo	v1
	addu	t3, t3, v1	# t3 += v1

	###  bit ڂ t3 ɓBa0 ɃZbgB
	### v1,t4 ͎g
	srl	v1, t3, 3	# v1=t3/8
	addu	t4, a0, v1	# t4=&a0[v1]
	andi	t3, t3, 7	# t3=t3%8
	li	v1, $80		# v1 = 0x80
	srlv	v1, v1, t3	# v1 >>= t3
	lbu	t3, (t4)	# t3 =*t4

	or	t3, t3, v1	# t3 |=v1
	sb	t3, (t4)

bitIsOff:

	sll	v0, v0, 1	# v0 <<= 1
	andi	v0, v0, $ffff
	beq	v0, zero, end2byte	# break;

	addiu	t2, t2, 1	# t2 ++;
	j	nextBit

end2byte:
	### 2byte 

	addiu	t0, t0, 1	# t0 ++;
	slt	v1, t0, t1	# v1 = (t0 < 15)
	bne	v1, zero, convMore

	jr	ra
.end	KanjiReduce



.globl	KanjiReduce12
.ent	KanjiReduce12
################################################################3
###	void KanjiReduce12(char *dest, const char *src);
###	a0	dest: 18bytes (144bits) 邾̗̈
###	a1	src: Kmem2RawAdd() ̖߂l
################################################################3
KanjiReduce12:
	addiu	sp, sp, -4
	sw	ra, (sp)

	li	a2, 12
	jal	KanjiReduce

	lw	ra, (sp)
	addiu	sp, sp, 4
	jr	ra

.end	KanjiReduce12

